<template>
  <div>
    <BlocItem v-for="help in displayHelps"
      :item="help"
    >
    </BlocItem>
    <nav aria-label="Page navigation">
      <ul class="pagination">
        <li class="page-item">
          <button class="page-link" type="button" v-if="page != 1" @click="page--"><<</button>
        </li>
        <li class="page-item">
          <button class="page-link" type="button" v-for="pageNumber in pages.slice(page-1, page+5)" @click="page = pageNumber">{{ pageNumber }}</button>
        </li>
        <li class="page-item">
          <button class="page-link" type="button" v-if="page < pages.length" @click="page++">>></button>
        </li>
      </ul>
    </nav>
    <p v-if="emptyHelps" class="alert color-green">{{ this.message }}</p>
  </div>



</template>

<script>
import BlocItem from "./BlocItem";
import axios from "axios"
export default {
  name: "HelpItem",
  components: {BlocItem},
  props: {
    url: {
      type: String,
      default:''
    },
    message: {
      type: String
    }
  },
  data() {
    return {
      helpItems : [],
      emptyHelps: true,
      page: 1,
      perPage: 5,
      pages: []
    }
  },
  mounted() {
    this.loadItems()
  },
  computed: {
    displayHelps() {
      return this.paginate(this.helpItems)
    }
  },
  methods: {
    setPages() {
      let numberOfPages = Math.ceil(this.helpItems.length / this.perPage)
      for (let index = 1; index <= numberOfPages; index++) {
        this.pages.push(index)
      }
    },
    paginate(items) {
      let page = this.page
      let perPage = this.perPage
      let from = (page*perPage)-perPage
      let to = (page * perPage)
      return items.slice(from, to)
    },
    loadItems(event){
      axios.get(this.url).then(response => {
          this.helpItems = response.data
          if (
              typeof this.helpItems != 'undefined' &&
              this.helpItems != null &&
              this.helpItems.length != null &&
              this.helpItems.length > 0
          ) {
            this.emptyHelps = false
          }
      })
    }
  },
  watch: {
    helpItems: function() {
        this.setPages()
    }
  },
  filters: {
    trimWords(value) {
      return value.split(" ").splice(0,20).join(" ")+ '...'
    }
  }
}
</script>

<style scoped>
  button.page-link {
    display: inline-block;
    font-size: 20px;
    color: #6d3e2e;
    background-color: #ffffff;
    font-weight: 500;
  }
  .offset {
    width: 500px !important;
    margin: 20px auto;
  }
</style>